
#ifndef GQPE_H
#define GQPE_H

#include "sll.h"

typedef sllNodeRef GQPERef;

GQPERef GQPECreate();
GQPERef GQPECreateWithIDAndCPUCount(const char* peID,unsigned int cpuCount);

GQPERef GQPERetain(GQPERef aPE);
void GQPERelease(GQPERef aPE);

const char* GQPEGetIdentifier(GQPERef aPE);
void GQPESetIdentifier(GQPERef aPE,const char* peID);

unsigned int GQPEGetCPUCount(GQPERef aPE);
void GQPESetCPUCount(GQPERef aPE,unsigned int cpuCount);

int GQPEGetRoundUp(GQPERef aPE);
void GQPESetRoundUp(GQPERef aPE,int roundUp);

int GQPEIsValid(GQPERef aPE);

void GQPESummarize(GQPERef aPE);

#endif
