#include "GQPEList.h"

#include <stdio.h>

int
main(
  const int         argc,
  const char*       argv[]
)
{
  int               argn = 1;
  
  while ( argn < argc ) {
    GQPEListRef     myPEList = GQPEListCreateWithXML(argv[argn]);
    
    if (myPEList) {
      GQPERef       myPE;
      unsigned int  nproc;
      
      GQPEListSummarize(myPEList);
      
      printf("Maximum processor count for this PE list = %d\n",GQPEListMaximumCPUCount(myPEList));
      
      for ( nproc = 1 ; nproc <= 20 ; nproc++ ) {
        unsigned int  start = nproc;
        
        if (myPE = GQPEListSelectPE(myPEList,&nproc)) {
          printf("Selected PE = %s @ %u processors (asked for %u)\n",GQPEGetIdentifier(myPE),nproc,start);
        } else {
          printf("No environment selected for %u processors!\n",nproc);
        }
        if (nproc > 4) nproc++;
      }
      
      GQPEListRelease(myPEList);
    }
    argn++;
  }
  return 0;
}
