//
//  strutils
//
//  Utility functions that do stuff to C strings.
//
//  Created by Jeffrey Frey on Tue Jan 10 2006.
//  Network & Systems Services
//  University of Delaware
//  Copyright (c) 2006
//

#ifndef STRUTILS_H
#define STRUTILS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <math.h>
#include <float.h>

void strtolower(char* s);
void strtoupper(char* s);

char* strnchr(const char* s,char c,size_t len);
char* strnchr(const char* s,char c,size_t len);
char* strncasestr(const char* big,const char* little,size_t len);
char* substrn(const char* s,size_t slen,size_t origin,size_t length);
char* strcatm(const char* s1,...);
char* strncatm(const char* s1,size_t l1,...);

#ifndef HAVE_FGETLN
char* fgetln(FILE* stream,size_t* len);
#endif

char* pathstr_pathByDeletingExtension(char* path,size_t plen);
char* pathstr_pathByDeletingLastComponent(char* path,size_t plen);
int pathstr_fileExists(const char* path);
int pathstr_isDirectory(const char* path);
int pathstr_isExecutable(const char* path);
char* pathstr_basenameForPath(const char* path);
char* pathstr_canonicalPath(const char* fname);

void logtostream(FILE* stream,const char* format,...);

#endif
